
/*
 * (C) Copyright 2005- ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 *
 * In applying this licence, ECMWF does not waive the privileges and immunities granted to it by
 * virtue of its status as an intergovernmental organisation nor does it submit to any jurisdiction.
 */

#pragma once

#include "grib_accessor_class_long.h"

class grib_accessor_g1forecastmonth_t : public grib_accessor_long_t
{
public:
    /* Members defined in g1forecastmonth */
    const char* verification_yearmonth;
    const char* base_date;
    const char* day;
    const char* hour;
    const char* fcmonth;
    const char* check;
};

class grib_accessor_class_g1forecastmonth_t : public grib_accessor_class_long_t
{
public:
    grib_accessor_class_g1forecastmonth_t(const char* name) : grib_accessor_class_long_t(name) {}
    grib_accessor* create_empty_accessor() override { return new grib_accessor_g1forecastmonth_t{}; }
    int pack_long(grib_accessor*, const long* val, size_t* len) override;
    int unpack_long(grib_accessor*, long* val, size_t* len) override;
    void dump(grib_accessor*, grib_dumper*) override;
    void init(grib_accessor*, const long, grib_arguments*) override;
};
